<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/5/17 17:57
 */
namespace api\controllers;

use common\classes\Common;
use common\classes\Error;
use common\models\CallWaiter;
use common\models\IpCall;
use common\models\VIpCall;
use Yii;

/**
 * IP Call controller
 */
class IpcallController extends BaseController
{
    public function actionOnhook($id){
        $token = Yii::$app->request->get('access_token');
        $model = IpCall::findOne(['id' => $id]);
        if(empty($model))
            return $this->response(Error::STATUS_IPCALL_NOT_EXISTS);
        $waiter = CallWaiter::findOne(['user' => Yii::$app->user->id, 'session' => $token]);
        if(empty($waiter) || (!is_null($model->waiter) && $model->waiter != $waiter->id))
            return $this->response(Error::STATUS_SUCCESS);
        $model->status = 'idle';
        if($model->save()) {
            $vmodel = VIpCall::findOne(['id' => $id]);
            return $this->response(Error::STATUS_SUCCESS, $vmodel);
        }
        return $this->response(Error::STATUS_FAILED);
    }

    public function actionOffhook($id){
        $token = Yii::$app->request->get('access_token');
        $model = IpCall::findOne(['id' => $id]);
        if(empty($model))
            return $this->response(Error::STATUS_IPCALL_NOT_EXISTS);
        if(!is_null($model->waiter))
            return $this->response(Error::STATUS_IPCALL_IS_TALKING);
        $waiter = CallWaiter::findOne(['user' => Yii::$app->user->id, 'session' => $token]);
        if(empty($waiter)) {
            $waiter = new CallWaiter();
            $waiter->user = Yii::$app->user->id;
            $waiter->session = $token;
            $waiter->save();
        }
        $model->waiter = $waiter->id;
        if($model->save()) {
            $vmodel = VIpCall::findOne(['id' => $id]);
            return $this->response(Error::STATUS_SUCCESS, $vmodel);
        }
        return $this->response(Error::STATUS_FAILED);
    }

    public function actionListen() {
        $token = Yii::$app->request->get('access_token');
        Yii::$app->db
            ->createCommand("insert into CallWaiter (user, session) values(" . Yii::$app->user->id . ", '$token') on duplicate key update updateAt = now()")
            ->execute();
        $waiter = CallWaiter::findOne(['user' => Yii::$app->user->id, 'session' => $token]);
        if(empty($waiter))
            return $this->response(Error::STATUS_FAILED);
        $call = VIpCall::find()
            ->select(['id', 'device', 'deviceName', 'waiter', 'ringing', 'status', 'direction', 'wsPort'])
            ->where("(`waiter` is null and `status`='ringing') or (`waiter`=" . $waiter->id . " and `status`='talking')")
            ->orderBy(['id' => SORT_ASC])
            ->asArray()
            ->one();
        return $this->response(Error::STATUS_SUCCESS, [$call]);
    }
}
