<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/5/2 15:34
 */
namespace api\controllers;
use common\classes\Error;
use common\models\VDeviceLog;
use Yii;

/**
 * Site controller
 */
class LogController extends BaseController
{
    public function actionList($end){
        if(!is_numeric($end))
            return $this->response(Error::STATUS_PARAM_ERROR);
        $startDate = Yii::$app->getRequest()->get('startDate');
        if(empty($startDate) || strptime($startDate, '%Y-%m-%d') == false)
            $startDate = '1000-01-01';

        $endDate = Yii::$app->getRequest()->get('endDate');
        if(empty($endDate) || strptime($endDate, '%Y-%m-%d') == false)
            $endDate = '9999-12-31';

        $data = Yii::$app->getRequest()->post('data');
        if(is_null($data)|| !isset($data['limit'])) {
            $data['limit'] = 200;
        }
        if(!isset($data['page'])) {
            $data['page'] = 0;
        }
        $query = VDeviceLog::find()
            ->andWhere("`DateTime` >= '$startDate 00:00:00' and `DateTime` < '$endDate 23:59:59' and (`EndTime` <= '$endDate 23:59:59' or `EndTime` is null)")
            ->andWhere("DevLogID <= $end");
        return $this->list($query, $data);
    }

    public function actionClean() {
        $startDate = Yii::$app->getRequest()->get('startDate');
        if(empty($startDate) || strptime($startDate, '%Y-%m-%d') == false)
            $startDate = '1000-01-01';

        $endDate = Yii::$app->getRequest()->get('endDate');
        if(empty($endDate) || strptime($endDate, '%Y-%m-%d') == false)
            $endDate = '9999-12-31';
        $this->logTitle['title1'] = $startDate;
        $this->logTitle['title2'] = $endDate;

        Yii::$app->db
            ->createCommand("Delete from `DeviceStatistic` where `StatisticDay` >= '$startDate' and `StatisticDay` <= '$endDate';")
            ->execute();
        $cnt = Yii::$app->db
            ->createCommand("DELETE a.* FROM DeviceLog a
                                    WHERE a.`DateTime` >= '$startDate 00:00:00'
                                    AND (a.`EndTime` < '$endDate 23:59:59'
                                        OR (a.`EndTime` IS NULL
                                            AND a.`DevLogID` NOT IN (SELECT
                                                *
                                            FROM
                                                (SELECT
                                                    DevLogID
                                                FROM
                                                    DeviceLog
                                                WHERE
                                                    `DateTime` >= '$endDate 23:59:59') AS tmp)))")
            ->execute();
        return $this->response(Error::STATUS_SUCCESS, ['rows' => $cnt]);
    }
}