<?php
/**
 * User: xuhj(xuhj@idste.cn)
 * Date: 2018/5/3 10:34
 */
namespace api\controllers;
use common\classes\Error;
use common\models\VDeviceStatistic;
use Yii;

/**
 * Device Statistic controller
 */
class StatisticController extends BaseController
{
    public function actionList(){
        $data = Yii::$app->getRequest()->post('data');
        if(is_null($data)|| !isset($data['limit'])) {
            $data['limit'] = 200;
        }
        if(!isset($data['page'])) {
            $data['page'] = 0;
        }
        $startDate = Yii::$app->getRequest()->get('startDate');
        if(empty($startDate) || strptime($startDate, '%Y-%m-%d') == false)
            $startDate = '1000-01-01';

        $endDate = Yii::$app->getRequest()->get('endDate');
        if(empty($endDate) || strptime($endDate, '%Y-%m-%d') == false)
            $endDate = '9999-12-31';

        $query = VDeviceStatistic::find()
            ->andWhere("`StatisticDay` >= '$startDate 00:00:00'")
            ->andWhere("`StatisticDay` <= '$endDate 23:59:59'");

        $this->listQuery($query, $data);
        $lists = $query->all();

        $ret = [];
        foreach ($lists as $item){
            if(!isset($ret[$item->DeviceID]))
                $ret[$item->DeviceID] = $item;
            else {
                for($i = 0; $i < 16; $i++) {
                    $key = 'power' . $i;
                    $ret[$item->DeviceID]->$key += $item->$key;
                    $key = 'power' . $i;
                    $ret[$item->DeviceID]->$key += $item->$key;
                }
            }
        }
        return $this->response(Error::STATUS_SUCCESS, ['count' => count($ret), 'list' => $ret]);
    }

    public function actionClean($startDate, $endDate) {
        if($startDate == 'null')
            $startDate = '1000-01-01';
        else if(strptime($startDate, '%Y-%m-%d') == false)
            return $this->response(Error::STATUS_PARAM_ERROR);
        if($endDate == 'null')
            $endDate = '9999-12-31';
        else if(strptime($endDate, '%Y-%m-%d') == false)
            return $this->response(Error::STATUS_PARAM_ERROR);
        $this->logTitle['title1'] = $startDate;
        $this->logTitle['title2'] = $endDate;
        $cnt = Yii::$app->db
            ->createCommand("delete from DeviceStatistic where StatisticDay >= '$startDate 00:00:00' and StatisticDay <= '$endDate 23:59:59';")
            ->execute();
        return $this->response(Error::STATUS_SUCCESS, ['rows' => $cnt]);
    }
}